Unit ClassDrivery;

Interface

Uses Sorting, Windows, ComCtrls,
     WinNTFunctions;

Const
      DRIVERY_SLOUPEC_NAME = 0;
      DRIVERY_SLOUPEC_FILENAME = 1;
      DRIVERY_SLOUPEC_BASE = 2;
      DRIVERY_SLOUPEC_SIZE = 3;
      DRIVERY_MAX_SLOUPCU = 4;

Type
     TDriverSortStyle = (dssName, dssFile, dssBase, dssSize);
     TDriverRecord = Record
                     FileName   : String;
                     DriverName : String;
                     BaseAddr   : DWORD;
                     Size       : DWORD;
                     Index      : Cardinal;
                     LoadCount  : Cardinal;
                     Link1, Link2 : Cardinal;
                     Flags      : Cardinal;
                     end;
     PDriverRecord = ^TDriverRecord;

     TDrivery = Class (TSortList)
                Private
                 FSortStyle : TDriverSortStyle;
                 Procedure PridejDriver(Driver:SYSTEM_MODULE_INFORMATION);
                Protected
                 Procedure SetSortStyle(H:TDriverSortStyle);
                 Function  JeVetsi(A,B:Pointer; K:Cardinal):Boolean; Override;
                 Function  JeRovno(A,B:Pointer; K:Cardinal):Boolean; Override;
                Public
                 Constructor Create(AListView:TListView); Override;
                 Destructor  Destroy; Override;

                 Procedure   ListViewVykresliJednoho(Sender:TObject; Item:TListItem);   Override;
                 Procedure   ListViewColumnClick(Sender: TObject; Column: TListColumn); Override;
                 Function    GetDriver(Index:Integer):PDriverRecord;
                 Procedure   ShowInfo(Index:Integer);
                 Procedure   Enumerate; Virtual;
                 Property SortStyle : TDriverSortStyle Read FSortStyle Write SetSortStyle;
                end;

Implementation

Uses SysUtils,
     ModuleInformationForm,
     Forms, ProceduresImport;

Const
      KRITERIUM_NAME     = 0;
      KRITERIUM_FILENAME = 1;
      KRITERIUM_BASE     = 2;
      KRITERIUM_SIZE     = 3;

Constructor TDrivery.Create(AListView:TListView);
begin
Inherited Create(AListView);
FSortStyle:=dssName;
Kriteria.Add(Pointer(KRITERIUM_NAME));
Opacne:=False;
PocetSloupcu:=DRIVERY_MAX_SLOUPCU;
FJmena.LoadFromFile('Data\driver.col');
end;

Destructor TDrivery.Destroy;
begin
Kriteria.Free;
Clear;
Inherited Destroy;
end;

Procedure TDrivery.SetSortStyle(H:TDriverSortStyle);
begin
If FSortStyle = H Then
   begin
   Opacne:= Not Opacne;
   end
Else begin
     Opacne:=False;
     FSortStyle:=H;
     Kriteria.Clear;
     Kriteria.Add(Pointer(KRITERIUM_NAME));
     Case H Of
          dssFile : Kriteria.Insert(0,Pointer(KRITERIUM_FILENAME));
          dssBase : Kriteria.Insert(0,Pointer(KRITERIUM_BASE));
          dssSize : Kriteria.Insert(0,Pointer(KRITERIUM_SIZE));
          end;
     end;
Serad;
end;

Procedure TDrivery.PridejDriver(Driver:SYSTEM_MODULE_INFORMATION);
Var X : PDriverRecord;
begin
New(X);
X.BaseAddr:=Cardinal(Driver.Base);
X.FileName:=Driver.ImageName;
X.DriverName:=ExtractFileName(X.FileName);
X.Size:=Driver.Size;
X.Index:=Driver.Index;
X.LoadCount:=Driver.LoadCount;
X.Flags:=Driver.Flags;
X.Link1:=Driver.Reserved[0];
X.Link2:=Driver.Reserved[1];
X.FileName:=KeModuleNameToFileName(X.FileName);
Add(X);
end;

Procedure TDrivery.Enumerate;
Type
      TSystemModuleArray = Array [0..1] Of SYSTEM_MODULE_INFORMATION;
      PSystemModuleArray = ^TSystemModuleArray;
      TSysModuleArray = Packed Record
                        Count : ULONG;
                        Modules : TSystemModuleArray;
                        end;
      PSysModuleArray = ^TSysModuleArray;
Var Pole : PSysModuleArray;
    Size : Cardinal;
    I : Integer;
begin
Clear;
Pole:=Nil;
Size:=0;
GetDeviceDriverList(Pole,Size);
If Size <> 0 Then
   begin
   GetMem(Pole,Size);
   If GetDeviceDriverList(Pole,Size) = STATUS_SUCCESS Then
      begin
      For I:=0 To Pole.Count-1 Do
          PridejDriver(Pole.Modules[I]);
      end;
   FreeMem(Pole);
   Serad;
   end;
If Assigned(FListView) Then
   begin
   FListView.Items.Count:=Count;
   FListView.Invalidate;
   end;
end;

Function  TDrivery.JeVetsi(A,B:Pointer; K:Cardinal):Boolean;
Var X,Y : PDriverRecord;
begin
X:=A;
Y:=B;
Case K Of
     KRITERIUM_NAME : Result:= AnsiStrComp(PAnsiChar(X.DriverName),PAnsiChar(Y.DriverName)) > 0;
     KRITERIUM_FILENAME : Result:= AnsiStrComp(PAnsiChar(X.FileName),PAnsiChar(Y.FileName)) > 0;
     KRITERIUM_BASE : Result:= X.BaseAddr > Y.BaseAddr;
     KRITERIUM_SIZE : Result:= X.Size > Y.Size;
     end;
end;

Function  TDrivery.JeRovno(A,B:Pointer; K:Cardinal):Boolean;
Var X,Y : PDriverRecord;
begin
X:=A;
Y:=B;
Case K Of
     KRITERIUM_NAME : Result:= AnsiStrComp(PAnsiChar(X.DriverName),PAnsiChar(Y.DriverName)) = 0;
     KRITERIUM_FILENAME : Result:= AnsiStrComp(PAnsiChar(X.FileName),PAnsiChar(Y.FileName)) = 0;
     KRITERIUM_BASE : Result:= X.BaseAddr = Y.BaseAddr;
     KRITERIUM_SIZE : Result:= X.Size = Y.Size;
     end;
end;

Function TDrivery.GetDriver(Index:Integer):PDriverRecord;
begin
Result:= Items[Index];
end;

Procedure TDrivery.ListViewVykresliJednoho(Sender:TObject; Item:TListItem);
Var D : PDriverRecord;
begin
D:=GetDriver(Item.Index);
With Item Do
     begin
     If SloupecDejStav(DRIVERY_SLOUPEC_NAME) Then
        Caption:=D.DriverName;
     If SloupecDejStav(DRIVERY_SLOUPEC_FILENAME) Then
        SubItems.Add(D.FileName);
     If SloupecDejStav(DRIVERY_SLOUPEC_BASE) Then
        SubItems.Add('$'+IntToHex(Int64(D.BaseAddr),8));
     If SloupecDejStav(DRIVERY_SLOUPEC_SIZE) Then
        SubItems.Add(IntToStr(Int64(D.Size))+' B');
     end;
end;

Procedure TDrivery.ListViewColumnClick(Sender: TObject; Column: TListColumn);
begin
Enumerate;
SortStyle:=TDriverSortStyle(Column.Tag);
end;

Procedure TDrivery.ShowInfo(Index:Integer);
Var D : PDriverRecord;
begin
D:=GetDriver(Index);
CreateModuleInformationForm(Application.Handle,0,D.FileName,D.BaseAddr);
end;

End.
