Unit ClassKernelObjects;

Interface

Uses Windows, Sorting, HandlesImport,
     ComCtrls;

Const
      KE_SLOUPEC_HANDLE = 0;
      KE_SLOUPEC_TYPE   = 1;
      KE_SLOUPEC_NAME   = 2;
      KE_MAX_SLOUPCU    = 3;

Type
      TKernelObjectRecord = ThandleRecord;
      PKernelObjectRecord = ^TKernelObjectRecord;
      TKeSortStyle = (koHandle, koType, koName);

      TKeObjects  = Class (TSortList)
                    Private
                     FPID : Cardinal;
                     FSortStyle : TKeSortStyle;
                    Protected
                     Procedure SetSortStyle(H:TKeSortStyle);             Reintroduce;
                     Function  JeVetsi(A,B:Pointer; K:Cardinal):Boolean; Override;
                     Function  JeRovno(A,B:Pointer; K:Cardinal):Boolean; Override;
                    Public
                     Constructor Create(AListView:TListView; APID:Cardinal); Reintroduce;
                     Procedure Enumerate; Override;
                     Procedure   ListViewVykresliJednoho(Sender:TObject; Item:TListItem);   Override;
                     Procedure   ListViewColumnClick(Sender: TObject; Column: TListColumn); Override;
                     Function  GetObject(Index:Integer):PKernelObjectRecord;
                     Procedure ShowContent(Index:Integer);
                     Property PID : Cardinal Read FPID;
                     Property SortStyle : TKeSortStyle Read FSortStyle Write SetSortStyle;
                    end;

Implementation

Uses SysUtils, Forms, ObjectContentForm,
     FMImport;

Const
      KRITERIUM_HANDLE = 0;
      KRITERIUM_TYPE   = 1;
      KRITERIUM_NAME   = 2;

Constructor TKeObjects.Create(AListview:TListView; APID:Cardinal);
begin
Inherited Create(AListView);
Kriteria.Add(Pointer(KRITERIUM_HANDLE));
PocetSloupcu:=KE_MAX_SLOUPCU;
FPID:=APID;
Opacne:=False;
FSortStyle:=koHandle;
FJmena.LoadFromFile(ExtractFilePath(Application.ExeName)+'Data\KeObject.col');
end;

Procedure TKeObjects.SetSortStyle(H:TKeSortStyle);
begin
If H = FSortStyle Then
   begin
   Opacne:= Not Opacne;
   Serad;
   Exit;
   end
Else begin
     Opacne:=False;
     Kriteria.Clear;
     Kriteria.Add(Pointer(KRITERIUM_HANDLE));
     FSortStyle:=H;
     Case H Of
          koHandle : Kriteria.Insert(0,Pointer(KRITERIUM_HANDLE));
          koType   : Kriteria.Insert(0,Pointer(KRITERIUM_TYPE));
          koName   : Kriteria.Insert(0,Pointer(KRITERIUM_NAME));
          end;
     Serad;
     end;
end;

Function TKeObjects.JeVetsi(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : PKernelObjectRecord;
begin
X:=A;
Y:=B;
Case K Of
     KRITERIUM_HANDLE : Result:= X.Handle > Y.Handle;
     KRITERIUM_TYPE   : Result:= AnsiStrComp(PAnsiChar(X.HandleType),PAnsiChar(Y.HandleType)) > 0;
     KRITERIUM_NAME   : Result:= AnsiStrComp(PAnsiChar(X.HandleName),PAnsiChar(Y.HandleName)) > 0;
     end;
end;

Function TKeObjects.JeRovno(A,B:Pointer; K:Cardinal):Boolean;
Var X, Y : PKernelObjectRecord;
begin
X:=A;
Y:=B;
Case K Of
     KRITERIUM_HANDLE : Result:= X.Handle = Y.Handle;
     KRITERIUM_TYPE   : Result:= AnsiStrComp(PAnsiChar(X.HandleType),PAnsiChar(Y.HandleType)) = 0;
     KRITERIUM_NAME   : Result:= AnsiStrComp(PAnsiChar(X.HandleName),PAnsiChar(Y.HandleName)) = 0;
     end;
end;

Var P : TKeObjects;

Procedure TKeObjects.Enumerate;

  Function EnumObjProc(A:TKernelObjectRecord):Boolean; StdCall;
  Var X : PKernelObjectRecord;
  begin
  New(X);
  X^:=A;
  P.Add(X);
  end;

begin
P:=Self;
If Assigned(FListView) Then
   FListView.Items.Count:=0;
Clear;
EnumKernelObjects(@EnumObjProc,FPID);
Serad;
If Assigned(FListView) Then
   begin
   FListView.Items.Count:=Count;
   FListView.Invalidate;
   end;
end;

Function  TKeObjects.GetObject(Index:Integer):PKernelObjectRecord;
begin
Result:= Items[Index];
end;

Procedure TKeObjects.ListViewVykresliJednoho(Sender:TObject; Item:TListItem);
Var H : PKernelObjectRecord;
begin
H:=GetObject(Item.Index);
With Item Do
     begin
     Caption:='$'+IntToHex(Int64(H.Handle),8);
     If SloupecDejStav(KE_SLOUPEC_TYPE) Then
        SubItems.Add(H.HandleType);
     If SloupecDejStav(KE_SLOUPEC_NAME) Then
        SubItems.Add(H.HandleName);
     end;
end;

Procedure TKeObjects.ListViewColumnClick(Sender: TObject; Column: TListColumn);
begin
SortStyle:=TKeSortStyle(Column.Tag);
Enumerate;
end;

Procedure TKeObjects.ShowContent(Index:Integer);
Var K : PKernelObjectRecord;
begin
K:=GetObject(Index);
If (K.HandleType = 'Soubor') Then
   CreateGetObjectContentForm(Application.Handle,K.Handle,HANDLE_TYPE_FILE,FPID,0,0)
Else If (K.HandleType = 'Namapovan soubor') Then
        CreateGetObjectContentForm(Application.Handle,K.Handle,HANDLE_TYPE_MAP_FILE,FPID,0,0)
end;

End.
