Unit ArProcesses;

Interface

Uses TProcImport, PProcImport, Classes;

Type  TPole = Array Of Cardinal;

Function  GetNumberOfProcessesByPSAPI:Cardinal; StdCall;
Function  GetNumberOfProcessesByToolHelpAPI:Cardinal; StdCall;
Function  GetNumberOfProcessesByOpenHandles:Cardinal; StdCall;

Function  GetProcessListByOpenHandles(Var APole:TPole):Cardinal;  StdCall;
Function  GetProcessListByPSAPI(Var APole:TPole):Cardinal; StdCall;
Function  GetProcessListByToolHelpAPI(Var APole:TPole):Cardinal; StdCall;

Procedure UserModeCheckHiddenProcesses(AStringList:TStringList); StdCall;

Implementation

Uses PSAPI, Windows, TlHelp32, OSVersion,
     WinNTFunctions, ProceduresImport,
     SysUtils;

Function GetNumberOfProcessesByPSAPI:Cardinal; StdCall;
Var PIDy : TPole;
begin
PIDy:=Nil;
If GetProcessListByPSAPI(PIDy) = STATUS_SUCCESS Then
   begin
   Result:=Length(PIDy);
   PIDy:=Nil;
   end
Else ErrorMessage('Pi vyhledvn skrytch proces dolo k chyb!');
end;

Function GetProcessListByPSAPI(Var APole:TPole):Cardinal; StdCall;
Var BigArray : Array [0..$FFFF] Of Cardinal;
    Needed : Cardinal;
    I, J : Integer;
begin
If EnumProcesses(@BigArray,SizeOf(BigArray),Needed) Then
   begin
   Result:= Needed Div SizeOf(Cardinal);
   For I:=0 To Result-1 Do
       begin
       For J:=0 To High(APole) Do
           begin
           If APole[J] = BigArray[I] Then
              Continue;
           If J = High(APole) Then
              begin
              SetLength(APole,Length(APole)+1);
              APole[High(APole)]:=BigArray[I];
              Break;
              end;
           end;
       If Length(APole) = 0 Then
          begin
          SetLength(APole,Length(APole)+1);
          APole[High(APole)]:=BigArray[I];
          end;
       end;
   Result:=STATUS_SUCCESS;
   end
Else Result:=STATUS_UNSUCCESSFUL;
end;

Function GetNumberOfProcessesByToolHelpAPI:Cardinal; StdCall;
Var PIDy : TPole;
begin
PIDy:=Nil;
If GetProcessListByToolHelpAPI(PIDy) = STATUS_SUCCESS Then
   begin
   Result:=Length(PIDy);
   PIDy:=Nil;
   end;
end;

Function GetProcessListByToolHelpAPI(Var APole:TPole):Cardinal; StdCall;
Var PE    : ProcessEntry32;
    hSnap : THandle;
    J : Integer;
begin
Result:=0;
If WinXP Or Win9xMe Then
   begin
   hSnap:=CreateToolHelp32Snapshot(TH32CS_SNAPPROCESS,0);
   If hSnap > 0 Then
      begin
      PE.dwSize:=SizeOf(PE);
      If Process32First(hSnap,PE) Then
         begin
         Repeat
         For J:=0 To High(APole) Do
             begin
             If APole[J] = PE.th32ProcessID Then
                Continue;
             If J = High(APole) Then
                begin
                SetLength(APole,Length(APole)+1);
                APole[High(APole)]:=PE.th32ProcessID;
                Break;
                end;
             end;
         If Length(APole) = 0 Then
            begin
            SetLength(APole,Length(APole)+1);
            APole[High(APole)]:=PE.th32ProcessID;
            end;
         Until Not Process32Next(hSnap,PE);
         Result:=STATUS_SUCCESS;
         end
      Else Result:=GetLastError;
      CloseHandle(hSnap);
      end
   Else Result:=GetLastError;
   end
Else Result:=STATUS_NOT_IMPLEMENTED;
end;

Function GetNumberOfProcessesByOpenHandles:Cardinal; StdCall;
Var PIDy : TPole;
begin
Result:=0;
PIDy:=Nil;
If GetProcessListByOpenHandles(PIDy) = STATUS_SUCCESS Then
   begin
   Result:=Length(PIDy);
   PIDy:=Nil;
   end
Else ErrorMessage('Chyba!');
end;

Function  GetProcessListByOpenHandles(Var APole:TPole):Cardinal;  StdCall;
Var HandleBasicInfo  : OBJECT_BASIC_INFORMATION;
    HandleTypeInfo   : POBJECT_TYPE_INFORMATION;
    SystemHandleInfo : PSYSTEM_HANDLE_INFORMATION;
    I, J             : Integer;
    Size             : Cardinal;
    Status           : NTSTATUS;
    S                : String;
    PID              : Cardinal;
    h                : THandle;
    hProcess         : THandle;
begin
Result:=STATUS_SUCCESS;
GetMem(SystemhandleInfo,1);
Status:=NtQuerySystemInformation(SystemHandleInformation,Nil,0,@Size);
While Status = STATUS_INFO_LENGTH_MISMATCH Do
      begin
      If Size = 0 Then
         Size:=16384
      Else Size:=Size*2;
      ReAllocMem(SystemHandleInfo,Size);
      Status:=NtQuerySystemInformation(SystemHandleInformation,SystemHandleInfo,Size,Nil);
      end;
If Status = STATUS_SUCCESS Then
   begin
   For I:=0 To SystemHandleInfo.NumberOfHandles-1 Do
       begin
       hProcess:=OpenProcess(PROCESS_DUP_HANDLE,False,SystemHandleInfo.Handles[I].UniqueProcessId);
       If hProcess = 0 Then
          begin
          ErrorMessage('OpenProcess: '+SysErrorMessage(GetLastError));
          Continue;
          end;
       Status:=NtDuplicateObject(hProcess,SystemHandleInfo.Handles[I].HandleValue,GetCurrentProcess,@h,DUPLICATE_SAME_ACCESS,0,DUPLICATE_SAME_ACCESS);
       If Status = STATUS_SUCCESS Then
          begin
          Status:=NtQueryObject(h,Cardinal(ObjectBasicInformation),@HandleBasicInfo,SizeOf(OBJECT_BASIC_INFORMATION),@Size);
          If Status = STATUS_SUCCESS Then
             begin
             GetMem(HandleTypeInfo,HandleBasicInfo.TypeInformationLength+MAX_PATH);
             Status:=NtQueryObject(h,Cardinal(ObjectTypeInformation),HandleTypeInfo,HandleBasicInfo.TypeInformationLength+MAX_PATH,@Size);
             If Status = STATUS_SUCCESS Then
                begin
                S:=Copy(String(HandleTypeInfo.Name.Buffer),1,HandleTypeInfo.Name.Length);
                If S = 'Process' Then
                   begin
                   PID:=GetProcessID(h);
                   For J:=0 To High(APole) Do
                       begin
                       If PID = APole[J] Then
                          Break
                       Else If J = High(APole) Then
                               begin
                               SetLength(APole,Length(APole)+1);
                               APole[High(APole)]:=PID;
                               Break;
                               end;
                       end;
                   If Length(APole) = 0 Then
                      begin
                      SetLength(APole,Length(APole)+1);
                      APole[High(APole)]:=PID;
                      end;
                   end;
                end
             Else begin
                  ErrorMessage('NtQueryObject (type): '+IntToHex(Int64(Status),8));
                  Result:=Status;
                  end;
             FreeMem(HandleTypeInfo);
             end
          Else begin
               ErrorMessage('NtQueryObject (basic): '+IntToHex(Int64(Status),8));
               Result:=Status;
               end;
          end
       Else begin
            ErrorMessage('NtDuplicateObject: '+IntToHex(Int64(Status),8));
            Result:=Status;
            end;
       NtClose(hProcess);
       NtClose(h);
       end;
   end
Else begin
     ErrorMessage('NtQuerySystemInformation: '+IntToHex(Int64(Status),8));
     Result:=Status;
     end;
FreeMem(SystemHandleInfo);
end;

Procedure UserModeCheckHiddenProcesses(AStringList:TStringList); StdCall;
Var PIDy1, PIDy2 : TPole;
begin
PIDy1:=Nil;
PIDy2:=Nil;
AStringList.Clear;
If GetProcessListByPSAPI(PIDy1) = STATUS_SUCCESS Then
   begin
   PIDy2:=Copy(PIDy1,0,Length(PIDy1));
   AStringList.Add('Method 1 found '+IntToStr(INt64(Length(PIDy1)))+' processes');
   end
Else AStringList.Add('Error! Cannot use method 1!');
If GetProcessListByToolHelpAPI(PIDy1) = STATUS_SUCCESS Then
   begin
   PIDy2:=Copy(PIDy1,0,Length(PIDy1));
   If Length(PIDy1) > Length(PIDy2) Then
      begin
      AStringList.Add('Method 2 found '+IntToStr(INt64(Length(PIDy1)-Length(PIDy2)))+' additional processes');
      end
   Else AStringList.Add('Method 2 found 0 additional processes');
   end
Else If GetProcessListByToolHelpAPI(PIDy1) <> STATUS_NOT_IMPLEMENTED Then
        AStringList.Add('Error! Cannot use method 2!');
If GetProcessListByOpenHandles(PIDy1) = STATUS_SUCCESS Then
   begin
   PIDy2:=Copy(PIDy1,0,Length(PIDy1));
   If Length(PIDy1) > Length(PIDy2) Then
      begin
      AStringList.Add('Method 3 found '+IntToStr(INt64(Length(PIDy1)-Length(PIDy2)))+' additional processes');
      end
   Else AStringList.Add('Method 3 found 0 additional processes');
   end
Else AStringList.Add('Error! Cannot use method 3!');
end;

End.
