Unit HandleEnumeration;

Interface

Uses Windows;

Type THandleRecord = Record
                     Handle          : DWORD;
                     HandleType      : String;
                     HandleName      : String;
                     References      : DWORD;
                     Access          : Cardinal;
                     HandleTypeNum   : Cardinal;
                     OriginalTypeNum : Cardinal;
                     pObject         : Pointer;
                     CreatorPID      : Cardinal;
                     end;
     PHandleRecord = ^THandleRecord;
     THandleArray = Array Of DWORD;
     TAllHandleArray = Array Of THandleRecord;
     TEnumHandlesProc = Function (AObject:THandleRecord):Boolean; StdCall;

Procedure EnumKernelObjects(EnumHandlesProc:TEnumHandlesProc; PID:Cardinal); StdCall;
Function  ConvertRegistryName(S:String):String; StdCall;
Function  UpravNazev(Nazev:String):String; StdCall;

Implementation

Uses OSVersion,
     SysUtils,
     PSAPI,
     Classes,
     ProceduresImport,
     NtTryObjectName,
     Win95Functions,
     WinNTFunctions,
     PProcImport,
     TProcImport;

Var ANames, APaths : TStringList;

Procedure FindDosDevices(ANames, APaths:TStringList); StdCall;
Label Znovu, Znovu2;
Var Buffer : PAnsiChar;
    S      : String;
    Pom    : PAnsiChar;
    Size   : Cardinal;
    A      : TStringList;
    I      : Integer;
begin
ANames.Clear;
APaths.Clear;
Size:=65536;
Znovu:
Buffer:=StrAlloc(Size);
If (QueryDosDevice(Nil,Buffer,Size-1) = 0) And
   (GetLastError = ERROR_MORE_DATA) Then
   begin
   StrDispose(Buffer);
   Size:=Size*2;
   Goto Znovu;
   end;
Pom:=Buffer;
While PByte(Buffer)^ <> 0 Do
      begin
      S:=Copy(String(Buffer),1,StrLen(Buffer));
      ANames.Add(S);
      Inc(Buffer,StrLen(Buffer)+1);
      end;
StrDispose(Pom);
For I:=0 To ANames.Count-1 Do
    begin
    Size:=512;
    Znovu2:
    Buffer:=StrAlloc(Size);
    If (QueryDosDevice(PAnsiChar(Anames[I]),Buffer,Size-1) = 0) And
       (GetLastError = ERROR_MORE_DATA) Then
       begin
       StrDispose(Buffer);
       Size:=Size*2;
       Goto Znovu2;
       end;
    S:=Copy(String(Buffer),1,StrLen(Buffer));
    APaths.Add(S);
    StrDispose(Buffer);
    end;
end;

Function ConvertRegistryName(S:String):String; StdCall;
Var SSid : String;
begin
Result:=S;
If Pos('\REGISTRY\',S) = 1 Then
   begin
   Delete(S,1,Length('\REGISTRY\'));
   Result:=S;
   If Pos('MACHINE',S) = 1 Then
      begin
      Delete(S,1,Length('MACHINE'));
      S:='HKLM'+S;
      Result:=S;
      end
   Else If Pos('USER\',S) = 1 Then
           begin
           Delete(S,1,Length('USER\'));
           SSid:=GetAccountStringSid;
           If SSid = '' Then
              Exit;
           If Length(S) < Length(SSid) Then
              Exit;
           If (Copy(S,1,Length(SSid)) = SSid) And
              ((Length(S) = Length(SSid)) Or (S[Length(SSid)+1] = '\')) Then
              begin
              Delete(S,1,Length(SSid));
              S:='HKCU'+S;
              Result:=S;
              end;
           end;
   end;
end;

Function UpravNazev(Nazev:String):String; StdCall;
Var I : Integer;
    Minimum : Cardinal;
begin
FindDosDevices(ANames,APaths);
Minimum:=MaxInt;
Result:=Nazev;
For I:=0 To APaths.Count-1 Do
    begin
    If (Pos(APaths[I],Nazev) = 1) And
       (Length(ANames[I]) < Minimum)  Then
       begin
       Result:=Nazev;
       Delete(Result,1,Length(APaths[I]));
       Result:=ANames[I]+Result;
       Minimum:=Length(APaths[I]);
       end;
    end;
end;

Procedure _EnumHandles(PID:DWORD; Var A:TAllHandleArray);
Label Znovu;
Const MAX_HANDLES = 65536;
Var I : Integer;
    HandleTable        : PProcessHandleTable;
    APID : Cardinal;
    NtHandleTable : PSYSTEM_HANDLE_INFORMATION;
    NtHandleTableSize : DWORD;
    NtHandleEntry : SYSTEM_HANDLE_TABLE_ENTRY_INFO;
    Returned          : ULONG;
    ObjTypeInfo       : POBJECT_TYPE_INFORMATION;
    ObjBasicInfo      : OBJECT_BASIC_INFORMATION;
    ObjNameInfo       : POBJECT_NAME_INFORMATION;
    h, SourceProcess  : THandle;
    FThread           : TNtTryObjectThread;
    Status            : NTSTATUS;
    Buffer            : PAnsiChar;
    TID               : Cardinal;
begin
FindDosDevices(ANames,APaths);
If WinNT Then
   begin
   NtHandleTableSize:=MAX_HANDLES*SizeOf(SYSTEM_HANDLE_TABLE_ENTRY_INFO)+SizeOf(DWORD);
   NtHandleTable:=AllocMem(NtHandleTableSize);
   Znovu:
   Status:=NtQuerySystemInformation(Cardinal(SystemHandleInformation),NtHandleTable,NtHandleTableSize,@Returned);
   If Status = STATUS_SUCCESS Then
      begin
      For I:=0 To NtHandleTable.NumberOfHandles-1 Do
          begin
          If NtHandleTable.Handles[I].UniqueProcessId = PID Then
             begin
             NtHandleEntry:=NtHandleTable.Handles[I];
             SetLength(A,Length(A)+1);
             A[High(A)].OriginalTypeNum:=Cardinal(NtHandleEntry.ObjectTypeIndex);
             A[High(A)].Access:=NtHandleEntry.GrantedAccess;
             A[High(A)].Handle:=NtHandleEntry.HandleValue;
             A[High(A)].HandleName:='';
             A[High(A)].pObject:=NtHandleEntry.Object_;
             If A[High(A)].HandleName = '' Then
                begin
                h:=0;
                SourceProcess:=OpenProcess(PROCESS_DUP_HANDLE,False,PID);
                If SourceProcess = 0 Then
                   Continue;
                NtDuplicateObject(SourceProcess,NtHandleEntry.HandleValue,GetCurrentProcess,@h,DUPLICATE_SAME_ACCESS,0,DUPLICATE_SAME_ACCESS);
                If h = 0 Then
                   Continue;
                CloseHandle(SourceProcess);
                If NtQueryObject(h,Cardinal(ObjectBasicInformation),@ObjBasicInfo,SizeOf(OBJECT_BASIC_INFORMATION),@Returned) = STATUS_SUCCESS Then
                   A[High(A)].References:=ObjBasicInfo.HandleCount;
                GetMem(ObjTypeInfo,ObjBasicInfo.TypeInformationLength+512);
                If NtQueryObject(h,Cardinal(ObjectTypeInformation),ObjTypeInfo,ObjBasicInfo.TypeInformationLength+512,@Returned) = STATUS_SUCCESS Then
                   A[High(A)].HandleType:=Copy(String(ObjTypeInfo.Name.Buffer),1,Length(String(ObjTypeInfo.Name.Buffer)));
                If A[High(A)].HandleType = 'File' Then
                   A[High(A)].HandleTypeNum:=KOBJECT_FILE
                Else If A[High(A)].HandleType = 'Process' Then
                        A[High(A)].HandleTypeNum:=KOBJECT_PROCESS
                Else If A[High(A)].HandleType = 'Thread' Then
                        A[High(A)].HandleTypeNum:=KOBJECT_THREAD
                Else If A[High(A)].HandleType = 'Event' Then
                        A[High(A)].HandleTypeNum:=KOBJECT_EVENT
                Else If A[High(A)].HandleType = 'Mutant' Then
                        A[High(A)].HandleTypeNum:=KOBJECT_MUTEX
                Else If A[High(A)].HandleType = 'Semaphore' Then
                        A[High(A)].HandleTypeNum:=KOBJECT_SEMAPHORE
                Else If A[High(A)].HandleType = 'Section' Then
                        begin
                        A[High(A)].HandleTypeNum:=KOBJECT_MEM_MAPPED_FILE;
                        A[High(A)].HandleType:='Namapovan soubor';
                        end;
                FreeMem(ObjTypeInfo);
                If A[High(A)].HandleType = 'Process' Then
                   begin
                   APID:=GetProcessID(h);
                   If APID <> 0 Then
                      A[High(A)].HandleName:=DejSouborProcesu(APID)
                   Else A[High(A)].HandleName:='<Nelze zjistit>';
                   end
                Else If (A[High(A)].HandleType = 'Thread') Then
                        begin
                        TID:=ThreadGetID(h);
                        If TID > 0 Then
                           begin
                           A[High(A)].HandleName:='$'+IntToHex(Int64(TID),8);
                           A[High(A)].HandleName:=DejSouborZTID(TID)+' ('+A[High(A)].HandleName+')';
                           end
                        Else A[High(A)].HandleName:='<nelze zjistit>';
                        end
                Else If ((A[High(A)].HandleType = 'File') And
                         (A[High(A)].Access And SYNCHRONIZE > 0)) Then
                        begin
                        A[High(A)].HandleName:='<nelze zjistit>';
                        FThread:=TNtTryObjectThread.Create(h);
                        If WaitForSingleObject(FThread.Handle,500) = WAIT_TIMEOUT Then
                           TerminateThread(FThread.Handle,1)
                        Else begin
                             Case FThread.FileType Of
                                  FILE_TYPE_PIPE     : A[High(A)].HandleType:='Roura';
                                  FILE_TYPE_DISK     : A[High(A)].HandleType:='Soubor';
                                  end;
                             GetMem(ObjNameInfo,ObjBasicInfo.NameInformationLength+512);
                             If NtQueryObject(h,Cardinal(ObjectNameInformation),ObjNameInfo,ObjBasicInfo.NameInformationLength+512,@Returned) = STATUS_SUCCESS Then
                                begin
                                A[High(A)].HandleName:=Copy(String(ObjNameInfo.Name.Buffer),1,Length(String(ObjNameInfo.Name.Buffer)));
                                A[High(A)].HandleName:=UpravNazev(A[High(A)].HandleName);
                                end;
                             FreeMem(ObjNameInfo);
                             end;
                        FThread.Free;
                        end
                Else begin
                     GetMem(ObjNameInfo,ObjBasicInfo.NameInformationLength+512);
                     If NtQueryObject(h,Cardinal(ObjectNameInformation),ObjNameInfo,ObjBasicInfo.NameInformationLength+512,@Returned) = STATUS_SUCCESS Then
                        begin
                        A[High(A)].HandleName:=Copy(String(ObjNameInfo.Name.Buffer),1,Length(String(ObjNameInfo.Name.Buffer)));
                        If A[High(A)].HandleType = 'Key' Then
                           A[High(A)].HandleName:=ConvertRegistryName(A[High(A)].HandleName)
                        Else A[High(A)].HandleName:=UpravNazev(A[High(A)].HandleName);
                        end;
                     FreeMem(ObjNameInfo);
                     end;
                NtClose(h);
                end;
             end;
          end;
      end
   Else begin
        ReAllocMem(NtHandleTable,Returned);
        Goto Znovu;
        end;
   FreeMem(NtHandleTable,NtHandleTableSize);
   end
Else If Win9xMe Then
        begin
        HandleTable:=Win95GetProcessHandleTable(PID);
        For I:=0 To HandleTable.dwMaxHandles-1 Do
            begin
            If (HandleTable.Handles[I].GuarantedAccess = 0) And
               (HandleTable.Handles[I].HObject = Nil)        Then
               Continue;
            SetLength(A,Length(A)+1);
            A[Length(A)-1].Handle:=I*4;
            A[Length(A)-1].References:=HandleTable.Handles[I].HObject.ObjectType Shr 16;
            A[Length(A)-1].Access:=HandleTable.Handles[I].GuarantedAccess;
            A[High(A)].HandleTypeNum:=ShortInt(HandleTable.Handles[I].HObject.ObjectType);
            A[High(A)].pObject:=HandleTable.Handles[I].HObject;
            Case ShortInt(A[High(A)].HandleTypeNum) Of
                 KOBJECT_SEMAPHORE : A[Length(A)-1].HandleType:='Semafor';
                 KOBJECT_EVENT     : A[Length(A)-1].HandleType:='Event';
                 KOBJECT_MUTEX     : A[Length(A)-1].HandleType:='Mutex';
                 KOBJECT_CRITICAL_SECTION : A[Length(A)-1].HandleType:='Kritick sekce';
                 KOBJECT_PROCESS : begin
                                   A[Length(A)-1].HandleType:='Proces';
                                   APID:= Cardinal(HandleTable.Handles[I].HObject) Xor GetObsfucator;
                                   A[High(A)].HandleName:=DejSouborZPID(APID);
                                   A[High(A)].HandleType:=A[High(A)].HandleType+' (PID $'+IntToHex(Int64(APID),8)+')';
                                   end;
                 KOBJECT_THREAD : begin
                                  A[Length(A)-1].HandleType:='Vlkno';
                                  APID:= Cardinal(HandleTable.Handles[I].HObject) Xor GetObsfucator;
                                  A[High(A)].HandleName:=DejSouborZTID(APID);
                                  A[High(A)].HandleType:=A[High(A)].HandleType+' (TID $'+IntToHex(Int64(APID),8)+')';
                                  end;
                 KOBJECT_FILE : A[Length(A)-1].HandleType:='Soubor';
                 KOBJECT_CHANGE : A[Length(A)-1].HandleType:='FileChangeNotification';
                 KOBJECT_CONSOLE : A[High(A)].HandleType:='Konzole';
                 KOBJECT_SCREEN_BUFFER : A[Length(A)-1].HandleType:='Screen Buffer';
                 KOBJECT_MEM_MAPPED_FILE : A[Length(A)-1].HandleType:='Namapovan soubor';
                 KOBJECT_SERIAL : A[Length(A)-1].HandleType:='Serial';
                 KOBJECT_DEVICE_IOCTL : A[Length(A)-1].HandleType:='Device Ioctl';
                 KOBJECT_PIPE : A[Length(A)-1].HandleType:='Roura';
                 KOBJECT_MAILSLOT : A[Length(A)-1].HandleType:='Mailslot';
                 KOBJECT_TOOLHELP_SNAPSHOT : A[Length(A)-1].HandleType:='ToolHelp snapshot';
                 KOBJECT_SOCKET : A[Length(A)-1].HandleType:='Socket'
                 Else A[Length(A)-1].HandleType:='<Neznm>';
                 end;
            end;
        end;
end;

Procedure EnumKernelObjects(EnumHandlesProc:TEnumHandlesProc; PID:Cardinal); StdCall;
Var A : TAllHandleArray;
    I : Integer;
begin
SetLength(A,0);
_EnumHandles(PID,A);
For I:=0 To High(A) Do
    begin
    If Not EnumHandlesProc(A[I]) Then
       Break;
    end;
SetLength(A,0);
end;

Initialization
ANames:=TStringList.Create;
APaths:=TStringList.Create;

Finalization
ANames.Free;
APaths.Free;
End.
