Unit bplprocedures;

Interface

Uses Windows, Controls, TlHelp32;

Const
    PROCESS_TERMINATE_TIMEOUT   = 5000;
    TERMINATE_THREAD_TIMEOUT    = 5000;

Procedure AdjustPrivileges; StdCall;
Procedure EnableWinControl(C:TWinControl; Enable:Boolean);    StdCall;
Procedure EnableAndHideWinControl(C:TWinControl; EH:Boolean); StdCall;
Procedure LogUserOff;                                         StdCall;
Procedure RebootComputer;                                     StdCall;
Procedure PowerOff;                                           StdCall;
Function  UniversalVirtualAllocEx(hProcess:THandle; lpBase:Pointer; RegionSize:Cardinal; dwAllocationType:Cardinal; dwProtect:DWORD):Pointer; StdCall;
Function  UniversalVirtualFreeEx(hProcess:THandle; lpBase:Pointer; dwSize:Cardinal; dwFreeType:Cardinal):Boolean;  StdCall;
Function  GetAccountStringSID:String; StdCall;
Procedure InformationMessage(Msg:String); StdCall;
Procedure WarningMessage(Msg:String); StdCall;
Procedure ErrorMessage(Msg:String); StdCall;
Function  WindowsDir:String; StdCall;
Function  GetDeviceDriverList(Buffer:Pointer; Var Size:Cardinal):Cardinal; StdCall;
Function  KeModuleNameToFileName(Name:String):String; StdCall;

Implementation

Uses
     SysUtils,
     OSVersion,
     TProcImport,
     WinNTFunctions,
     Win95Functions;

Function GetHInstanceFromWindow(hwnd:HWND):Cardinal;
begin
Result:=GetWindowLong(hwnd,GWL_HINSTANCE);
end;


Procedure AdjustPrivileges;

Type
  	pRtlAdjustPrivilege = Function (Privilege:DWORD; NewValue,ForThread:Boolean; Var OldValue:Boolean):Integer; StdCall;

Var RtlAdjustPrivilege : pRtlAdjustPrivilege;
    OldValue : Boolean;
    hNTDLL : hMODULE;
    I : Integer;
begin
If WinNT Then
   begin
   OldValue:=False;
   hNTDLL:=LoadLibrary('NTDLL.DLL');
   If hNTDLL > 0 Then
      begin
      RtlAdjustPrivilege:=GetProcAddress(hNTDLL,'RtlAdjustPrivilege');
      If Assigned(RtlAdjustPrivilege) Then
         begin
         For I:=0 To $FFFF Do
             RtlAdjustPrivilege(I,True,False,OldValue);
        end
      Else WarningMessage('VRTULE''S TSK MANAGERU se nepodailo se nepodailo najt export RtlAdjustPrivilege!');
      end
   Else WarningMessage('Nepodailo se najt knihovnu NTDLL.DLL');
   end;
end;


Procedure EnableWinControl(C:TWinControl; Enable:Boolean);
begin
C.Enabled:=Enable;
end;

Procedure EnableAndHideWinControl(C:TWinControl; EH:Boolean);
begin
EnableWinControl(C,EH);
C.Visible:=EH;
end;


Procedure LogUserOff;
begin
ExitWindowsEx(EWX_LOGOFF,0)
end;

Procedure RebootComputer;
begin
ExitWindowsEx(EWX_REBOOT,0)
end;

Procedure PowerOff;
begin
ExitWindowsEx(EWX_POWEROFF,0)
end;

Function  UniversalVirtualAllocEx(hProcess:THandle; lpBase:Pointer; RegionSize:Cardinal; dwAllocationType:Cardinal; dwProtect:DWORD):Pointer; StdCall;
begin
Result:=Nil;
If WinXP Or Win2000 Then
   Result:=VirtualAllocEx(hProcess,lpBase,RegionSize,dwAllocationType,dwProtect)
Else If Win9xMe Then
        Win95VirtualAllocEx(lpBase,RegionSize,dwAllocationType,dwProtect)
end;

Function  UniversalVirtualFreeEx(hProcess:THandle; lpBase:Pointer; dwSize:Cardinal; dwFreeType:Cardinal):Boolean;  StdCall;
begin
Result:=False;
If WinXP Or Win2000 Then
   Result:=(VirtualFreeEx(hProcess,lpBase,dwSize,dwFreeType) <> Nil)
Else If Win9xMe Then
        Result:=Win95VirtualFreeEx(lpBase,dwSize,dwFreeType);
end;

Function  GetAccountStringSID:String; StdCall;
Var Buffer : PAnsiChar;
    pSidName : ^SID_NAME_USE;
    Size     : Cardinal;
    UserName : String;
    pSID     : Pointer;
    DomainName : PAnsiChar;
    DomainNameSize : Cardinal;
    SidSize        : Cardinal;
    hAdvApi32        : Cardinal;
    pConvertSidToStringSid : Function (Sid:Pointer; Var StringSid:PAnsiChar):Boolean; StdCall;
begin
Result:='';
DomainNameSize:=512;
Size:=512;
Buffer:=StrAlloc(Size);
If GetUserName(Buffer,Size) Then
   begin
   UserName:=Copy(String(Buffer),1,StrLen(Buffer));
   StrDispose(Buffer);
   SidSize:=4096;
   DomainNameSize:=512;
   DomainName:=StrAlloc(DomainNameSize);
   GetMem(pSid,SidSize);
   GetMem(pSidName,SizeOf(pSidName));
   If LookupAccountName(Nil,PAnsiChar(UserName),pSid,SidSize,PAnsiChar(DomainName),DomainNameSize,Cardinal(pSidName)) Then
      begin
      hAdvApi32:=LoadLibrary('advapi32.dll');
      If hAdvApi32 > 0 Then
         begin
         Buffer:=Nil;
         pConvertSidToStringSid:=GetProcAddress(hAdvApi32,'ConvertSidToStringSidA');
         If (Assigned(pConvertSidToStringSid)) And
            (pConvertSidToStringSid(pSid,Buffer)) Then
            begin
            Result:=Copy(String(Buffer),1,StrLen(Buffer));
            LocalFree(Cardinal(Buffer));
            end
         Else ErrorMessage('ConvertSidToStringSid: '+SysErrorMessage(GetLastError));
         FreeLibrary(hAdvApi32);
         end
      Else ErrorMessage('LoadLibrary: '+SysErrorMessage(GetLastError));
      end
   Else ErrorMessage('LookUpAccountName: '+SysErrorMessage(GetLastError));
   //FreeMem(pSid,SidSize);
   //FreeMem(pSidName);
   //StrDispose(DomainName);
   end
Else begin
     ErrorMessage('GetUserName: '+SysErrorMessage(GetLastError));
     StrDispose(Buffer);
     end;
end;

Procedure InformationMessage(Msg:String); StdCall;
begin
MessageBox(0,PAnsiChar(Msg),'Chyba',MB_OK Or MB_ICONINFORMATION);
end;

Procedure WarningMessage(Msg:String); StdCall;
begin
MessageBox(0,PAnsiChar(Msg),'Pozor!',MB_OK Or MB_ICONWARNING);
end;

Procedure ErrorMessage(Msg:String); StdCall;
begin
MessageBox(0,PAnsiChar(Msg),'Informace',MB_OK Or MB_ICONERROR);
end;

Function  WindowsDir:String; StdCall;
Var Buffer : PAnsiChar;
    Size : Cardinal;
begin
Buffer:=StrAlloc(512);
Size:=GetWindowsDirectory(Buffer,512);
Result:=Copy(Buffer,1,Size);
StrDispose(Buffer);
end;

Function  GetDeviceDriverList(Buffer:Pointer; Var Size:Cardinal):Cardinal; StdCall;
begin
Result:=STATUS_NOT_IMPLEMENTED;
If Not WinNT Then
   Exit;
Result:=NtQuerySystemInformation(SystemModuleInformation,Buffer,Size,@Size);
end;

Function  KeModuleNameToFileName(Name:String):String; StdCall;
begin
If Pos('\??\',Name) = 1 Then
   System.Delete(Name,1,4);
If Pos('\SystemRoot',Name) = 1 Then
   begin
   System.Delete(Name,1,Length('\SystemRoot'));
   Name:=WindowsDir+Name;
   end;
If Pos('\WINDOWS',Name) = 1 Then
   Name:=Copy(WindowsDir,1,2)+Name;
Result:=Name;
end;

End.
