Unit OsVersion;

/////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                         //
// Soubor: OSVERSION.PAS								   //
// Autor : Vrtule(X) vrtulex@seznam.cz							   //
// Popis : Tato jednotka obsahuje diagnostick funkce pro zjitn verze OS		   //
//											   //
/////////////////////////////////////////////////////////////////////////////////////////////

Interface

Function Win95:Boolean;
// Vrt True, pokud je OS Windows 95
Function Win98:Boolean;
// Vrt True, pokud je OS Windows 98
Function WinMe:Boolean;
// Vrt true, pokud je OS Windows ME
Function WinNT3:Boolean;
// Vrt True, pokud je OS Windows NT 3.0
Function WinNT4:Boolean;
// Vrt True, pokud je OS Windows NT 4.0
Function Win2000:Boolean;
// Vrt True, pokud je OS Windows 2000
Function WinXP:Boolean;
// Vrt True, pokud je OS Windows XP
Function Win9x:Boolean;
// Vrt True, pokud je OS Windows 95/98
Function Win9xMe:Boolean;
// Vrt True, pokud je OS Windows 95/98/ME
Function WinNT:Boolean;
// Vrt True, pokud je OS Windows NT3/NT4/XP

Implementation

Uses Windows;

Var FWin95, FWin98, FWinME, FWinNT3,
    FWinNT4, FWin2000, FWinXP : Boolean;

Function Win95:Boolean;
begin
Result:=FWin95;
end;

Function Win98:Boolean;
begin
Result:=FWin98;
end;

Function WinME:Boolean;
begin
Result:=FWinME;
end;

Function WinNT3:Boolean;
begin
Result:=FWinNT3;
end;

Function WinNT4:Boolean;
begin
Result:=FWinNT4;
end;

Function Win2000:Boolean;
begin
Result:=FWin2000;
end;

Function WinXP:Boolean;
begin
Result:=FWinXP;
end;

Function Win9x:Boolean;
begin
Result:= Win95 Or Win98;
end;

Function Win9xMe:Boolean;
begin
Result:= Win9x Or WinME;
end;

Function WinNT:Boolean;
begin
Result:= WinXP Or WinNT3 Or WinNT4 Or Win2000;
end;

Procedure GetOsVersion;
Var X : OSVersionInfo;
begin
X.DwOSVersionInfoSize:=SizeOf(X);
GetVersionEx(X);
Case X.dwPlatformId Of
     VER_PLATFORM_WIN32_WINDOWS :
          begin
          Case X.dwMinorVersion of
               0  : FWin95:=True;
               10 : FWin98:=True;
               90 : FWinME:=True;
               end;
          end;
     VER_PLATFORM_WIN32_NT :
          begin
          Case X.dwMajorVersion Of
               3 : FWinNT3:=True;
               4 : FWinNT4:=True;
               5 : begin
                   Case X.dwMinorVersion Of
                        0: FWin2000:=True;
                        1: FWinXP:=True;
                        end;
                   end;
               end;
          end;
     end;
end;

Initialization
FWin95:=False;
FWin98:=False;
FWinME:=False;
FWinNT3:=False;
FWinNT4:=False;
FWin2000:=False;
FWinXP:=False;
GetOSVersion;
End.
