Unit ProceduresImport;

Interface

Uses Windows, Controls, Win95Functions;

Procedure AdjustPrivileges;
Procedure EnableWinControl(C:TWinControl; Enable:Boolean);
Procedure EnableAndHideWinControl(C:TWinControl; EH:Boolean);
Procedure LogUserOff;
Procedure RebootComputer;
Procedure PowerOff;
Function  GetObsfucator:Cardinal;
Function  UniversalVirtualAllocEx(hProcess:THandle; lpBase:Pointer; RegionSize:Cardinal; dwAllocationType:Cardinal; dwProtect:DWORD):Pointer; StdCall;
Function  UniversalVirtualFreeEx(hProcess:THandle; lpBase:Pointer; dwSize:Cardinal; dwFreeType:Cardinal):Boolean;  StdCall;
Function  GetAccountStringSid:String; StdCall;
Procedure InformationMessage(Msg:String); StdCall;
Procedure WarningMessage(Msg:String); StdCall;
Procedure ErrorMessage(Msg:String); StdCall;
Function  WindowsDir:String; StdCall;
Function  GetDeviceDriverList(Buffer:Pointer; Var Size:Cardinal):Cardinal; StdCall;
Function  KeModuleNameToFileName(Name:String):String; StdCall;

Implementation

Uses SysUtils,
     WinNTFunctions;


Type
    TEnableWinControl = Procedure (C:TWinControl; Enable:Boolean); StdCall;
    TEnableAndHideWinControl = Procedure (C:TWinControl; EH:Boolean); StdCall;
    TLogUserOff = Procedure; StdCall;
    TRebootComputer = Procedure; StdCall;
    TPowerOff = Procedure; StdCall;
    TGetObsfucator = Function : Cardinal; StdCall;
    TAdjustPrivileges = Procedure; StdCall;
    TUniversalVirtualAllocEx = Function (hProcess:THandle; lpBase:Pointer; RegionSize:Cardinal; dwAllocationType:Cardinal; dwProtect:DWORD):Pointer; StdCall;
    TUniversalVirtualFreeEx = Function (hProcess:THandle; lpBase:Pointer; dwSize:Cardinal; dwFreeType:Cardinal):Boolean;  StdCall;
    TGetAccountStringSid = Function :String; StdCall;
    TInformationMessage = Procedure (Msg:String); StdCall;
    TWarningMessage     = Procedure (Msg:String); StdCall;
    TErrorMessage       = Procedure (Msg:String); StdCall;
    TWindowsDir         = Function :String; StdCall;
    TGetDeviceDriverList = Function (Buffer:Pointer; Var Size:Cardinal):Cardinal; StdCall;
    TKeModuleNameToFileName = Function (Name:String):String; StdCall;

Var
    _EnableWinControl : TEnableWinControl;
    _EnableAndHideWinControl : TEnableAndHideWinControl;
    _LogUserOff     : TLogUserOff;
    _RebootComputer : TRebootComputer;
    _PowerOff       : TPowerOff;
    _GetObsfucator : TGetObsFucator;
    _AdjustPrivileges : TAdjustPrivileges;
    _UniversalVirtualAllocEx : TUniversalVirtualAllocEx;
    _UniversalVirtualFreeEx  : TUniversalVirtualFreeEx;
    _GetAccountStringSid : TGetAccountStringSid;
    _ErrorMessage : TErrorMessage;
    _WarningMessage : TWarningMessage;
    _InformationMessage : TInformationMessage;
    _WindowsDir : TWindowsDir;
    _GetDeviceDriverList : TGetDeviceDriverList;
    _KeModuleNameToFileName : TKeModuleNameToFileName;

Procedure AdjustPrivileges;
begin
_AdjustPrivileges;
end;


Procedure EnableWinControl(C:TWinControl; Enable:Boolean);
begin
_EnableWinControl(C,Enable);
end;

Procedure EnableAndHideWinControl(C:TWinControl; EH:Boolean);
begin
_EnableAndHideWinControl(C,EH);
end;

Procedure LogUserOff;
begin
_LogUserOff;
end;

Procedure RebootComputer;
begin
_RebootComputer;
end;

Procedure PowerOff;
begin
_PowerOff;
end;

Function GetObsfucator:Cardinal;
begin
Result:=_GetObsfucator;
end;

Function  UniversalVirtualAllocEx(hProcess:THandle; lpBase:Pointer; RegionSize:Cardinal; dwAllocationType:Cardinal; dwProtect:DWORD):Pointer; StdCall;
begin
Result:=_UniversalVirtualAllocEx(hProcess,lpBase,RegionSize,dwAllocationType,dwProtect);
end;

Function  UniversalVirtualFreeEx(hProcess:THandle; lpBase:Pointer; dwSize:Cardinal; dwFreeType:Cardinal):Boolean;  StdCall;
begin
Result:=_UniversalVirtualFreeEx(hProcess,lpBase,dwSize,dwFreeType);
end;

Function  GetAccountStringSid:String; StdCall;
begin
Result:=_GetAccountStringSid;
end;

Procedure InformationMessage(Msg:String); StdCall;
begin
_InformationMessage(Msg);
end;

Procedure WarningMessage(Msg:String); StdCall;
begin
_WarningMessage(Msg);
end;

Procedure ErrorMessage(Msg:String); StdCall;
begin
_ErrorMessage(Msg);
end;

Function  WindowsDir:String; StdCall;
begin
Result:=_WindowsDir;
end;

Function  GetDeviceDriverList(Buffer:Pointer; Var Size:Cardinal):Cardinal; StdCall;
begin
Result:=_GetDeviceDriverList(Buffer,Size);
Size:=Size*SizeOf(SYSTEM_MODULE_INFORMATION);
end;

Function  KeModuleNameToFileName(Name:String):String; StdCall;
begin
Result:=_KeModuleNameToFileName(Name);
end;

Var hPackage : THandle;
Initialization
hPackage:=LoadLibrary('Procedures.dll');
If hPackage > 0 Then
   begin
   _AdjustPrivileges:=GetProcAddress(hPackage,'AdjustPrivileges');
   _EnableWinControl:=GetProcAddress(hPackage,'EnableWinControl');
   _EnableAndHideWinControl:=GetProcAddress(hPackage,'EnableAndHideWinControl');
   _LogUserOff:=GetProcAddress(hPackage,'LogUserOff');
   _RebootComputer:=GetProcAddress(hPackage,'RebootComputer');
   _PowerOff:=GetProcAddress(hPackage,'PowerOff');
   _GetObsfucator:=GetProcAddress(hPackage,'GetObsfucator');
   _UniversalVirtualAllocEx:=GetProcAddress(hPackage,'UniversalVirtualAllocEx');
   _UniversalVirtualFreeEx:=GetProcAddress(hPackage,'UniversalVirtualFreeEx');
   _GetAccountStringSid:=GetProcAddress(hPackage,'GetAccountStringSid');
   _InformationMessage:=GetProcAddress(hPackage,'InformationMessage');
   _ErrorMessage:=GetProcAddress(hPackage,'ErrorMessage');
   _WarningMessage:=GetProcAddress(hPackage,'WarningMessage');
   _WindowsDir:=GetProcAddress(hPackage,'WindowsDir');
   _GetDeviceDriverList:=GetProcAddress(hPackage,'GetDeviceDriverList');
   _KeModuleNameToFileName:=GetProcAddress(hPackage,'KeModuleNameToFileName');
   end
Else begin
     MessageBox(0,PAnsiChar(SysErrorMessage(GetLastError)),'Error',MB_OK Or MB_ICONERROR);
     ExitProcess(1);
     end;
End.
