Unit TProcImport;

Interface

Uses Windows, TlHelp32;

Const THREAD_QUERY_INFORMATION    = $40;
      THREAD_SET_INFORMATION      = $20;
      THREAD_SET_THREAD_CONTEXT   = $80;
      THREAD_SUSPEND_RESUME       = $2;
      THREAD_TERMINATE            = $1;
      THREAD_ALL_ACCESS           = $1F03FF;
      THREAD_GET_CONTEXT          = $8;
      THREAD_DIRECT_IMPRESONATION = $200;
      THREAD_IMPERSONATE          = $100;
      THREAD_SET_CONTEXT          = $10;
      THREAD_SYNCHRONIZE          = $100000;

Function  UniversalOpenThread(dwDesiredAccess:Cardinal; fInherit:Boolean; TID:Cardinal):Cardinal;
Function UniversalThreadSetContext(TID:Cardinal; Context: _CONTEXT):Boolean;  StdCall;
Function UniversalThreadGetContext(TID:Cardinal; Var Context: _CONTEXT):Boolean;  StdCall;
Function ThreadGetID(hThread:Thandle):Cardinal; StdCall;
Function ThreadSearchInit:THandle;  StdCall;
Function ThreadSearchFirst(hSearch:Thandle; Var TE:ThreadEntry32):Boolean; StdCall;
Function ThreadSearchNext(hSearch:THandle; Var TE:ThreadEntry32):Boolean;  StdCall;
Procedure ThreadSearchDestroy(hSearch:THandle); StdCall;

Implementation

Type
    TUniversalOpenThread = Function (dwDesiredAccess:Cardinal; fInherit:Boolean; TID:Cardinal):Cardinal; StdCall;
    TUniversalThreadSetContext = Function (TID:Cardinal; Context: _CONTEXT):Boolean;         StdCall;
    TUniversalThreadGetContext = Function (TID:Cardinal; Var Context: _CONTEXT):Boolean;     StdCall;

    TThreadGetID = Function (hThread:Thandle):Cardinal; StdCall;
    TThreadSearchInit = Function :THandle;  StdCall;
    TThreadSearchFirst = Function (hSearch:Thandle; Var TE:ThreadEntry32):Boolean; StdCall;
    TThreadSearchNext = Function (hSearch:THandle; Var TE:ThreadEntry32):Boolean;  StdCall;
    TThreadSearchDestroy = Procedure (hSearch:THandle); StdCall;

Var
    _UniversalOpenThread : TUniversalOpenThread;
    _UniversalThreadGetContext : TUniversalThreadGetContext;
    _UniversalThreadSetContext : TUniversalThreadSetContext;
    _ThreadSearchInit          : TThreadSearchInit;
    _ThreadSearchFirst         : TThreadSearchFirst;
    _ThreadSearchNext          : TThreadSearchNext;
    _ThreadSearchDestroy       : TThreadSearchDestroy;
    _ThreadGetID               : TThreadGetID;

Function  UniversalOpenThread(dwDesiredAccess:Cardinal; fInherit:Boolean; TID:Cardinal):Cardinal;
begin
Result:=_UniversalOpenThread(dwDesiredAccess,FInherit,TID);
end;

Function UniversalThreadSetContext(TID:Cardinal; Context: _CONTEXT):Boolean;
begin
Result:=_UniversalThreadSetContext(TID,Context);
end;

Function UniversalThreadGetContext(TID:Cardinal; Var Context: _CONTEXT):Boolean;
begin
Result:=_UniversalThreadGetContext(TID,Context);
end;

Function ThreadGetID(hThread:Thandle):Cardinal; StdCall;
begin
Result:=_ThreadGetID(hThread);
end;

Function ThreadSearchInit:THandle;  StdCall;
begin
Result:=_ThreadSearchInit;
end;

Function ThreadSearchFirst(hSearch:Thandle; Var TE:ThreadEntry32):Boolean; StdCall;
begin
Result:=_ThreadSearchFirst(hSearch,TE);
end;

Function ThreadSearchNext(hSearch:THandle; Var TE:ThreadEntry32):Boolean;  StdCall;
begin
Result:=_ThreadSearchNext(hSearch,TE);
end;

Procedure ThreadSearchDestroy(hSearch:THandle); StdCall;
begin
ThreadSearchDestroy(hSearch);
end;

Var hMod : THandle;
Initialization
hMod:=LoadLibrary('TProc.dll');
If hMod > 0 Then
   begin
   _UniversalOpenThread:=GetProcAddress(hMod,'UniversalOpenThread');
   _UniversalThreadGetContext:=GetProcAddress(hMod,'UniversalThreadGetContext');
   _UniversalThreadSetContext:=GetProcAddress(hMod,'UniversalThreadSetContext');
   _ThreadSearchFirst:=GetProcAddress(hMod,'ThreadSearchFirst');
   _ThreadSearchInit:=GetProcAddress(hMod,'ThreadSearchInit');
   _ThreadSearchNext:=GetProcAddress(hMod,'ThreadSearchNext');
   _ThreadSearchDestroy:=GetProcAddress(hMod,'ThreadSearchDestroy');
   _ThreadGetID:=GetProcAddress(hMod,'ThreadGetID');
   end
Else MessageBox(0,'Nebyl nalezen soubor TPROC.DLL. Monosti Process Inspectoru jsou vrazn omezen!','Soubor nenalezen!',MB_OK Or MB_ICONERROR);
End.
