Library ssdt;

{$R *.RES}

Uses
  ShareMem,
  Windows,
  Forms,
  SysUtils,
  ioctls in '..\inc\ioctls.pas',
  DriversImport in '..\inc\DriversImport.pas',
  ProceduresImport in '..\inc\ProceduresImport.pas',
  Win95Functions in '..\inc\Win95Functions.pas',
  WinNTFunctions in '..\inc\WinNTFunctions.pas',
  OsVersion in '..\inc\OsVersion.pas';

Var hDriver : THandle;

Function GetSSDT(SSDTFunction:TSSDTRoutine):Boolean; StdCall;
Var SSDT : PSystemServiceDescriptorTable;
    Size : Cardinal;
    I : Integer;
begin
GetMem(SSDT,SizeOf(TSystemServiceDescriptorTable));
ZeroMemory(SSDT,SizeOf(TSystemServiceDescriptorTable));
Size:=SizeOf(SSDT);
Result:=False;
Result:=DeviceIoControl(hDriver,IOCTL_GMEM_GSSDT,Nil,0,SSDT,SizeOf(TSystemServiceDescriptorTable),Size,Nil);
If Result Then
   begin
   Size:=SSDT.FunctionCount;
   For I:=0 To Size-1 Do
       If Not SSDTFunction(SSDT.DescriptorBase,SSDT.DispatchBase,SSDT.FunctionCount,I,SSDT.Addresses[I]) Then
              begin
              InformationMessage('Breaking');
              Break;
              end;
   end
Else ErrorMessage('DeviceIoControl: '+SysErrorMessage(GetLastError));
FreeMem(SSDT);
end;

Procedure LoadGMemDriver;
Var Err : Integer;
begin
InstallDriver(ExtractFilePath(Application.ExeName)+'Drivers\gmem.sys','gmem');
LoadDriver('gmem');
hDriver:=CreateFile('\\.\\gmem',GENERIC_READ Or GENERIC_WRITE,FILE_SHARE_READ Or FILE_SHARE_WRITE,Nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
If (Integer(hDriver) = Integer(INVALID_HANDLE_VALUE)) Or
   (hDriver = 0) Then
   begin
   ErrorMessage('CreateFile: '+SysErrorMessage(GetLastError));
   UnLoadDriver('gmem');
   UnInstallDriver('gmem');
   end;
end;

Procedure UnLoadGMemDriver;
Var A : Integer;
begin
If hDriver <> INVALID_HANDLE_VALUE Then
   begin
   CloseHandle(hDriver);
   UnLoadDriver('gmem');
   UnInstallDriver('gmem');
   end;
end;

Exports
  GetSSDT;

Procedure  DLLMain(dwReason:Cardinal);
begin
If Not WinNT Then
   Exit;
Case dwReason Of
     DLL_PROCESS_ATTACH : LoadGmemDriver;
     DLL_PROCESS_DETACH : UnLoadGMemDriver;
     end;
end;

Begin
DisableThreadLibraryCalls(HInstance);
DLLProc:=@DLLMain;
DLLMain(DLL_PROCESS_ATTACH);
End.
