Unit MainForm;

Interface

Uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ClassProcesy,
  ClassServices, ClassDrivery, Menus,
  ClassSSDT, StdCtrls;

Type
  TForm1 = Class (TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    ProcesyListView: TListView;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Refresh1: TMenuItem;
    Konec1: TMenuItem;
    Npovda1: TMenuItem;
    Oprogramu1: TMenuItem;
    Procesy1: TMenuItem;
    Pozastavit1: TMenuItem;
    Probudit1: TMenuItem;
    Ukonitnsiln1: TMenuItem;
    Ukonitstandardn1: TMenuItem;
    Podrobnosti1: TMenuItem;
    SluzbyListView: TListView;
    DriveryListView: TListView;
    Ovladae1: TMenuItem;
    Vceinformac1: TMenuItem;
    SSDTListView: TListView;
    ARRichEdit: TRichEdit;
    Procedure FormCreate(Sender: TObject);
    Procedure FormDestroy(Sender: TObject);
    Procedure Konec1Click(Sender: TObject);
    Procedure Refresh1Click(Sender: TObject);
    Procedure Pozastavit1Click(Sender: TObject);
    Procedure Probudit1Click(Sender: TObject);
    Procedure Ukonitnsiln1Click(Sender: TObject);
    Procedure Ukonitstandardn1Click(Sender: TObject);
    Procedure PageControl1Change(Sender: TObject);
    Procedure Podrobnosti1Click(Sender: TObject);
    Procedure Vceinformac1Click(Sender: TObject);
  Private
   FProcesy : TProcesy;
   FSluzby  : TSluzby;
   FDrivery : TDrivery;
   FSSDT    : TSSDT;
  end;

Var
  Form1: TForm1;

Implementation

Uses OSVersion, ShellAPI, ImgList,
     AntiRootkit;

{$R *.DFM}

Procedure TForm1.FormCreate(Sender: TObject);
Var Zaznam : _SHFILEINFOA;
    A : TImageList;
begin
If Win9xMe Then
   begin
   TabSheet2.TabVisible:=False;
   TabSheet3.TabVisible:=False;
   TabSheet4.TabVisible:=False;
   TabSheet5.TabVisible:=False;
   TabSheet6.TabVisible:=False;
   end;
A:=TImageList.Create(ProcesyListView);
A.Handle:=ShGetFileInfo(PAnsiChar(Application.ExeName),0,Zaznam,SizeOf(Zaznam),SHGFI_ICON Or SHGFI_SMALLICON Or SHGFI_SYSICONINDEX);
A.ShareImages:=True;
ProcesyListView.SmallImages:=A;
FProcesy:=TProcesy.Create(ProcesyListView);
With FProcesy Do
     begin
     SloupecZmenStav(PROCESY_SLOUPEC_EXEFILE,True);
     SloupecZmenStav(PROCESY_SLOUPEC_EXEPATH,True);
     SloupecZmenStav(PROCESY_SLOUPEC_PID,True);
     SloupecZmenStav(PROCESY_SLOUPEC_PRIORITA,True);
     SloupecZmenStav(PROCESY_SLOUPEC_VLAKNA,True);
     SloupecZmenStav(PROCESY_SLOUPEC_PARENT,True);
     UpravSloupceNaListViewu;
     Enumerate;
     end;
If WinNT Then
   begin
   FSluzby:=TSluzby.Create(SluzbyListView);
   With FSluzby Do
        begin
        SloupecZmenStav(SLUZBY_SLOUPEC_DISPLAYNAME,True);
        SloupecZmenStav(SLUZBY_SLOUPEC_NAME,True);
        SloupecZmenStav(SLUZBY_SLOUPEC_TYPE,True);
        SloupecZmenStav(SLUZBY_SLOUPEC_STATUS,True);
        UpravSloupceNaListViewu;
        end;
   FDrivery:=TDrivery.Create(DriveryListView);
   With FDrivery Do
        begin
        SloupecZmenStav(DRIVERY_SLOUPEC_NAME,True);
        SloupecZmenStav(DRIVERY_SLOUPEC_FILENAME,True);
        SloupecZmenStav(DRIVERY_SLOUPEC_BASE,True);
        SloupecZmenStav(DRIVERY_SLOUPEC_SIZE,True);
        UpravSloupceNaListViewu;
        end;
   FSSDT:=TSSDT.Create(SSDTListView);
   With FSSDT Do
        begin
        SloupecZmenStav(SSDT_SLOUPEC_INDEX,True);
        SloupecZmenStav(SSDT_SLOUPEC_NAME,True);
        SloupecZmenStav(SSDT_SLOUPEC_ADDRESS,True);
        SloupecZmenStav(SSDT_SLOUPEC_MODULENAME,True);
        SloupecZmenStav(SSDT_SLOUPEC_OADDRESS,True);
        SloupecZmenStav(SSDT_SLOUPEC_OMODULENAME,True);
        UpravSloupceNaListViewu;
        end;
   end;
end;

Procedure TForm1.FormDestroy(Sender: TObject);
begin
FProcesy.Free;
FDrivery.Free;
FSluzby.Free;
FSSDT.Free;
end;

Procedure TForm1.Konec1Click(Sender: TObject);
begin
Close;
end;

Procedure TForm1.Refresh1Click(Sender: TObject);
begin
Case PageControl1.ActivePageIndex Of
     0 : FProcesy.Enumerate;
     1 : FSluzby.Enumerate;
     2 : FDrivery.Enumerate;
     3 : FSSDT.Enumerate;
     5 : AntiRootkitCheck;
     end;
end;

Procedure TForm1.Pozastavit1Click(Sender: TObject);
begin
If Assigned(ProcesyListView.Selected) Then
   FProcesy.Suspend(ProcesyListView.Selected.Index)
end;

Procedure TForm1.Probudit1Click(Sender: TObject);
begin
If Assigned(ProcesyListView.Selected) Then
   FProcesy.Resume(ProcesyListView.Selected.Index)
end;

Procedure TForm1.Ukonitnsiln1Click(Sender: TObject);
begin
If Assigned(ProcesyListView.Selected) Then
   FProcesy.Terminate(ProcesyListView.Selected.Index)
end;

Procedure TForm1.Ukonitstandardn1Click(Sender: TObject);
begin
If Assigned(ProcesyListView.Selected) Then
   FProcesy.OkTerminate(ProcesyListView.Selected.Index)
end;

Procedure TForm1.PageControl1Change(Sender: TObject);
begin
Refresh1Click(Nil);
end;

Procedure TForm1.Podrobnosti1Click(Sender: TObject);
begin
If Assigned(ProcesyListView.Selected) Then
   FProcesy.ShowInfo(ProcesyListView.Selected.Index);
end;

Procedure TForm1.Vceinformac1Click(Sender: TObject);
begin
If Assigned(DriveryListView.Selected) Then
   FDrivery.ShowInfo(DriveryListView.Selected.Index);
end;

End.
