Unit ObjectContentForm;

Interface

Uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs, FMImport, ProceduresImport, ComCtrls;

Type
  TObjectContent = class(TForm)
    ListView1: TListView;
    Procedure FormCreate(Sender: TObject);
    Procedure ListView1Data(Sender: TObject; Item: TListItem);
    procedure FormActivate(Sender: TObject);
  Private
   FHandle : THandle;
   FPID    : Cardinal;
   FType   : Cardinal;
   FBuffer : PBuffer;
   FSize   : Cardinal;
   FBase   : Cardinal;
   Konec   : Boolean;
  Public
   Constructor Create(AOwner:TComponent; APID, AType, AHandle, ABase,ASize:Cardinal); Reintroduce;
  end;

Procedure CreateGetObjectContentForm(AppHandle:THandle; AHandle, AType, APID, ABase,ASize:Cardinal); StdCall;

Implementation

{$R *.DFM}

Procedure CreateGetObjectContentForm(AppHandle:THandle; AHandle, AType, APID, ABase, ASize:Cardinal); StdCall;
begin
Application.Handle:=AppHandle;
With TObjectContent.Create(Application,APID,AType,AHandle,ABase,ASize) Do
     begin
     ShowModal;
     Free;
     end;
end;

Constructor TObjectContent.Create(AOwner:TComponent; APID, AType, AHandle,ABase, ASize:Cardinal);
begin
Inherited Create(AOwner);
FPID:=APID;
FHandle:=AHandle;
FType:=AType;
FBuffer:=Nil;
FSize:=ASize;
FBase:=ABase;
Konec:=False;
Case FType Of
     HANDLE_TYPE_FILE : Caption:='Obsah souboru ';
     HANDLE_TYPE_MAP_FILE : Caption:='Obsah namapovanho souboru';
     HANDLE_TYPE_MEMORY : Caption:='Obsah pamti - PID $'+IntToHex(Int64(FPID),8)+' Adresa $'+IntToHex(Int64(FBase),8);
     end;
end;

Procedure TObjectContent.FormCreate(Sender: TObject);
Var Pom : Cardinal;
begin
Pom:=ERROR_MORE_DATA;
If Assigned(FBuffer) Then
   begin
   FreeMem(FBuffer);
   FBuffer:=Nil;
   end;
If (FType <> HANDLE_TYPE_MEMORY) Then
   begin
   FSize:=0;
   GetObjectContent(FHandle,FType,FPID,FBuffer,FSize);
   Pom:=GetLastError;
   end;
ListView1.Items.Count:=0;
If FSize = 0 Then
   begin
   InformationMessage('Soubor m nulovou velikost!');
   Konec:=True;
   end
Else If Pom = ERROR_MORE_DATA Then
        begin
        GetMem(FBuffer,FSize);
        GetObjectContent(FHandle,FType,FPID,FBuffer,FSize);
        Pom:=GetLastError;
        If (Pom <> NO_ERROR) Then
           begin
           ErrorMessage(SysErrorMessage(GetLastError));
           FreeMem(FBuffer);
           Konec:=True;
           end
        Else begin
             ListView1.Items.Count:=FSize;
             If (FType <> HANDLE_TYPE_MEMORY) Then
                FSize:=0;
             end;
        end
Else begin
     ErrorMessage(SysErrorMessage(Pom));
     Konec:=True;
     end;
end;


Procedure TObjectContent.ListView1Data(Sender: TObject; Item: TListItem);

 Function IntToBin(A:Int64; Dig:Byte):String;
 begin
 Result:='';
 While (A <> 0) And (Dig > 0) Do
       begin
       Result:=IntToStr(A Mod 2)+Result;
       A:=A Div 2;
       Dec(Dig);
       end;
 While Dig > 0 Do
       begin
       Result:='0'+Result;
       Dec(Dig);
       end;

 end;

Var I : Integer;
    Hex, Bin, Dec, Offset : String;
    Zn : Char;
begin
I:=Item.Index;
Hex:=IntToHex(FBuffer[I],2)+'h';
Dec:=IntToStr(FBuffer[I]);
Zn:=Chr(FBuffer[I]);
Offset:='$'+IntToHex(Int64(FBase+I),8);
Bin:=IntToBin(FBuffer[I],8)+'b';
With Item Do
     begin
     Caption:=Offset;
     SubItems.Add(Hex);
     SubItems.Add(Bin);
     SubItems.Add(Dec);
     SubItems.Add(Zn);
     end;
end;

Procedure TObjectContent.FormActivate(Sender: TObject);
begin
If Konec Then
   Close;
end;

End.
