Unit ProcessInfoForm;

Interface

Uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ClassProcesy,
  ClassModule, ClassVlakna, Menus,
  ClassMemPages, ClassKernelObjects,
  ClassTokeny;

Type
  TProcessInfo = Class (TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    TabSheet9: TTabSheet;
    ModulyListView: TListView;
    VlaknaListView: TListView;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Refresh1: TMenuItem;
    Konec1: TMenuItem;
    Moduly1: TMenuItem;
    Pidat1: TMenuItem;
    Odebrat1: TMenuItem;
    Importyaexporty1: TMenuItem;
    Vlkna1: TMenuItem;
    Uspat1: TMenuItem;
    Probudit1: TMenuItem;
    Ukonit1: TMenuItem;
    KeObjectsListView: TListView;
    MemPagesListView: TListView;
    Objektjdra1: TMenuItem;
    Obsah1: TMenuItem;
    Vceinformac2: TMenuItem;
    Oblastipamti1: TMenuItem;
    Obsahoblasti1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Vceinformac1: TMenuItem;
    TokenyListView: TListView;
    Procedure PageControl1Change(Sender: TObject);
    Procedure FormDestroy(Sender: TObject);
    Procedure Importyaexporty1Click(Sender: TObject);
    Procedure Refresh1Click(Sender: TObject);
    Procedure Konec1Click(Sender: TObject);
    Procedure Obsah1Click(Sender: TObject);
    Procedure Obsahoblasti1Click(Sender: TObject);
    Procedure Pidat1Click(Sender: TObject);
    Procedure Odebrat1Click(Sender: TObject);
    Procedure Uspat1Click(Sender: TObject);
    Procedure Probudit1Click(Sender: TObject);
    Procedure Ukonit1Click(Sender: TObject);
  Private
    FPID    : Cardinal;
    FInfo   : PProcess;
    FModuly : TModuly;
    FVlakna : TVlakna;
    FMemPages : TMemPages;
    FKeObjects : TKeObjects;
    FTokeny    : TTokeny;
  Public
    Constructor Create(AOwner:TComponent; AInfo:PProcess); Reintroduce; Virtual;
  end;

Procedure CreateInfoOProcesuForm(AHandle:THandle; AInfo:Pointer); StdCall;

Implementation

Uses ShellAPI, ProceduresImport;

Procedure CreateInfoOProcesuForm(AHandle:THandle; AInfo:Pointer); StdCall;
begin
Application.Handle:=AHandle;
With TProcessInfo.Create(Application,AInfo) Do
     begin
     ShowModal;
     Free;
     end;
end;

{$R *.DFM}

Constructor TProcessInfo.Create(AOwner:TComponent; AInfo:PProcess);
Var Zaznam : _SHFILEINFOA;
begin
Inherited Create(AOwner);
FInfo:=AInfo;
FPID:=AInfo.th32ProcessID;
FModuly:=TModuly.Create(ModulyListView,FPID);
With FModuly Do
     begin
     SloupecZmenStav(MODULY_SLOUPEC_NAME,True);
     SloupecZmenStav(MODULY_SLOUPEC_PATH,True);
     SloupecZmenStav(MODULY_SLOUPEC_BASE,True);
     SloupecZmenStav(MODULY_SLOUPEC_SIZE,True);
     SloupecZmenStav(MODULY_SLOUPEC_REFS,True);
     UpravSloupceNaListViewu;
     end;
With ModulyListView Do
     begin
     SmallImages:=TImageList.Create(ModulyListView);
     SmallImages.ShareImages:=True;
     SmallImages.Handle:=SHGetFileInfo(PAnsiChar(Application.ExeName),0,Zaznam,SizeOf(Zaznam),SHGFI_ICON Or SHGFI_SYSICONINDEX Or SHGFI_SMALLICON);
     DestroyIcon(Zaznam.hIcon);
     end;
FVlakna:=TVlakna.Create(VlaknaListView,FPID);
With FVlakna Do
     begin
     SloupecZmenStav(VLAKNA_SLOUPEC_TID,True);
     SloupecZmenStav(VLAKNA_SLOUPEC_PRIORITY,True);
     SloupecZmenStav(VLAKNA_SLOUPEC_SUSPENDED,True);
     UpravSloupceNaListViewu;
     end;
FMemPages:=TMemPages.Create(MemPagesListView,FPID);
With FMemPages Do
     begin
     SloupecZmenStav(MEMPAGES_SLOUPEC_ADDR,True);
     SloupecZmenStav(MEMPAGES_SLOUPEC_SIZE,True);
     SloupecZmenStav(MEMPAGES_SLOUPEC_TYPE,True);
     SloupecZmenStav(MEMPAGES_SLOUPEC_INITIALACCESS,True);
     SloupecZmenStav(MEMPAGES_SLOUPEC_ACCESS,True);
     SloupecZmenStav(MEMPAGES_SLOUPEC_TYPE2,True);
     SloupecZmenStav(MEMPAGES_SLOUPEC_NAME,True);
     UpravSloupceNaListViewu;
     end;
FKeObjects:=TKeObjects.Create(KeObjectsListView,FPID);
With FKeObjects Do
     begin
     SloupecZmenStav(KE_SLOUPEC_HANDLE,True);
     SloupecZmenStav(KE_SLOUPEC_TYPE,True);
     SloupecZmenStav(KE_SLOUPEC_NAME,True);
     UpravSloupceNaListViewu;
     end;
FTokeny:=TTokeny.Create(TokenyListView,False,FPID);
With FTokeny Do
     begin
     SloupecZmenStav(TOKENY_SLOUPEC_NAME,True);
     SloupecZmenStav(TOKENY_SLOUPEC_STATUS,True);
     UpravSloupceNaListViewu;
     end;
end;

Procedure TProcessInfo.PageControl1Change(Sender: TObject);
begin
Case PageControl1.ActivePageIndex Of
     1 : FModuly.Enumerate;
     2 : FVlakna.Enumerate;
     4 : FKeObjects.Enumerate;
     5 : FMemPages.Enumerate;
     7 : FTokeny.Enumerate;
     end;
end;

Procedure TProcessInfo.FormDestroy(Sender: TObject);
begin
FModuly.Free;
FVlakna.Free;
FMemPages.Free;
FKeObjects.Free;
FTokeny.Free;
end;

Procedure TProcessInfo.Importyaexporty1Click(Sender: TObject);
begin
If Assigned(ModulyListView.Selected) Then
   FModuly.ShowInfo(ModulyListView.Selected.Index);
end;

Procedure TProcessInfo.Refresh1Click(Sender: TObject);
begin
PageControl1Change(Nil);
end;

Procedure TProcessInfo.Konec1Click(Sender: TObject);
begin
Close;
end;

Procedure TProcessInfo.Obsah1Click(Sender: TObject);
begin
If Assigned(KeObjectsListView.Selected) Then
   FKeObjects.ShowContent(KeObjectsListView.Selected.Index);
end;

Procedure TProcessInfo.Obsahoblasti1Click(Sender: TObject);
begin
If Assigned(MemPagesListview.Selected) Then
   FMemPages.ShowContent(MemPagesListView.Selected.Index);
end;
Procedure TProcessInfo.Pidat1Click(Sender: TObject);
begin
If OpenDialog1.Execute Then
   FModuly.Inject(OpenDialog1.Filename);
end;

Procedure TProcessInfo.Odebrat1Click(Sender: TObject);
begin
If Assigned(ModulyListview.Selected) Then
   If Not FModuly.Remove(ModulyListview.Selected.Index) Then
          ErrorMessage('Modul se nepodailo odebrat!');
end;

Procedure TProcessInfo.Uspat1Click(Sender: TObject);
begin
If Assigned(VlaknaListView.Selected) Then
   FVlakna.Suspend(VlaknaListview.Selected.Index);
end;

Procedure TProcessInfo.Probudit1Click(Sender: TObject);
begin
If Assigned(VlaknaListView.Selected) Then
   FVlakna.Resume(VlaknaListview.Selected.Index);
end;

procedure TProcessInfo.Ukonit1Click(Sender: TObject);
begin
If Assigned(VlaknaListView.Selected) Then
   FVlakna.Terminate(VlaknaListview.Selected.Index);
end;

End.
