Unit Sorting;

Interface

Uses Windows, Classes, ComCtrls;

Type
     TKriteria = TList;
     TStejnaCast = Record
                   Min,
                   Max : Integer;
                   end;
     TSloupce = Set Of 0..32;

     TSortList = Class (TList)
                 Private
                  FOpacne : Boolean;
                  FKriteria : TKriteria;
                  Procedure Prohod(A,B:Integer);
                  Procedure Sort(Min,Max:Integer);   Virtual;
                  Procedure SortOpacne(Min,Max:Integer);
                  Procedure Setrid(Min,Max:Cardinal);
                 Private
                  FPocetSloupcu : Cardinal;
                  FSloupce : TSloupce;
                  Procedure ListViewPridejSloupec(Cislo:Integer);
                 Protected
                  FJmena : TStringList;
                  Function  JeVetsi(A,B:Pointer; K:Cardinal):Boolean; Virtual; Abstract;
                  Function  JeRovno(A,B:Pointer; K:Cardinal):Boolean; Virtual; Abstract;
                  Function  JeVetsiEx(A,B:Pointer):Boolean;
                  Function  JeMensiEx(A,B:Pointer):Boolean;
                  Procedure SetSloupce(H:TSloupce);
                  Function  JmenoSloupceNaCislo(Jmeno:String):Integer;
                  Function  CisloSloupceNaJmeno(Cislo:Integer):String;
                 Public
                  FListView : TListView;
                  Procedure Serad;
                  Constructor Create(AListView:TListView);  Reintroduce; Virtual;
                  Destructor  Destroy; Override;
                  Procedure   Delete(Index:Integer); Reintroduce; Virtual;
                  Procedure   Clear; Override;
                  Procedure   Enumerate; Virtual; Abstract;

                  Function  SloupecDejStav(Cislo:Integer):Boolean;
                  Procedure SloupecZmenStav(Cislo:Integer; Pridej:Boolean);
                  Procedure UpravSloupceNaListViewu;

                  Procedure ListViewVykresliJednoho(Sender:TObject; Item:TListItem);   Virtual; Abstract;
                  Procedure ListViewColumnClick(Sender: TObject; Column: TListColumn); Virtual; Abstract;

                  Property Sloupce : TSloupce Read FSloupce Write SetSloupce;
                  Property PocetSloupcu : Cardinal Read FPocetSloupcu Write FPocetSloupcu;
                  Property Items;
                  Property Count;
                  Property Opacne : Boolean Read FOpacne Write FOpacne;
                  Property Kriteria : TKriteria Read FKriteria Write FKriteria;
                  Property ListView : TListView Read FListView Write FListView;
                 end;

Implementation

Constructor TSortList.Create(AListView:TListView);
begin
Inherited Create;
FKriteria:=TKriteria.Create;
FJmena:=TStringList.Create;
FListView:=AListView;
If Assigned(FListView) Then
   begin
   FListView.OnData:=ListViewVykresliJednoho;
   FListView.OnColumnClick:=ListViewColumnClick;
   end;
FPocetSloupcu:=0;
FSloupce:=[];
end;

Destructor TSortList.Destroy;
begin
FKriteria.Free;
FJmena.Free;
Inherited Destroy;
end;

Procedure TSortList.Setrid(Min, Max:Cardinal);
begin
Sort(Min,Max);
end;

Procedure TSortList.Serad;
begin
If Count > 0 Then
   Setrid(0,Count-1);
If Assigned(FListView) Then
   FListView.Invalidate;
end;

Procedure TSortList.Prohod(A,B:Integer);
Var Pom : Pointer;
begin
Pom:=Items[A];
Items[A]:=Items[B];
Items[B]:=Pom;
end;

Procedure TSortList.SortOpacne(Min,Max:Integer);
Var X: Pointer;
    I,J: integer;
begin
I:=Min;
J:=Max;
X:=Items[(Min+Max) div 2];
Repeat
While JeMensiEx(X,Items[I]) Do Inc(I);
While JeVetsiEx(X,Items[J]) Do Dec(J);
If I < J Then
   begin
   Prohod(I,J);
   Inc(I);
   Dec(J);
   end
Else If I = J Then
      begin
      Inc(I);
      Dec(J);
      end
Until I > J;
If Min < J Then SortOpacne(Min,J);
If I < Max Then SortOpacne(I,Max);
end;

Procedure TSortList.Sort(Min,Max:Integer);
Var X    : Pointer;
    I, J : Integer;
begin
If FOpacne Then
   begin
   SortOpacne(Min,Max);
   Exit;
   end;
I:=Min;
J:=Max;
X:=Items[Min];
Repeat
While JeVetsiEx(X,Items[I]) Do Inc(I);
While JeMensiEx(X,Items[J]) Do Dec(J);
If I < J Then
   begin
   Prohod(I,J);
   Inc(I);
   Dec(J);
   end
Else If I = J Then
      begin
      Inc(I);
      Dec(J);
      end
Until I > J;
If Min < J Then Sort(Min,J);
If I < Max Then Sort(I,Max);
end;

Function TSortList.JeVetsiEx(A,B:Pointer):Boolean;
Var I : Integer;
begin
Result:=False;
If A = B Then
   Exit;
For I:=0 To FKriteria.Count-1 Do
    begin
    If JeRovno(A,B,Cardinal(FKriteria[I])) Then
       begin
       Result:=False;
       Continue;
       end;
    If JeVetsi(A,B,Cardinal(FKriteria[I])) Then
       begin
       Result:=True;
       Break;
       end
    Else begin
         Result:=False;
         Break;
         end;
    end;
end;

Function TSortList.JeMensiEx(A,B:Pointer):Boolean;
Var I : Integer;
begin
Result:=False;
If A = B Then
   Exit;
For I:=0 To FKriteria.Count-1 Do
    begin
    If JeRovno(A,B,Cardinal(FKriteria[I])) Then
       begin
       Result:=False;
       Continue;
       end;
    If JeVetsi(A,B,Cardinal(FKriteria[I])) Then
       begin
       Result:=False;
       Break;
       end
    Else begin
         Result:=True;
         Break;
         end;
    end;
end;

Procedure TSortList.Delete(Index:Integer);
begin
Dispose(Items[Index]);
Items[Index]:=Nil;
Inherited Delete(Index);
end;

Procedure TSortList.Clear;
begin
While Count > 0 Do
      Delete(0);
Inherited Clear;
end;

Procedure TSortList.ListViewPridejSloupec(Cislo:Integer);
begin
With FListView.Columns.Add Do
     begin
     Caption:=CisloSloupceNaJmeno(Cislo);
     DisplayName:=CisloSloupceNaJmeno(Cislo);
     Tag:=Cislo;
     AutoSize:=True;
     end;
end;

Procedure TSortList.SetSloupce(H:TSloupce);
begin
FSloupce:=H;
UpravSloupceNaListViewu;
end;

Procedure TSortList.UpravSloupceNaListViewu;
Var I : Integer;
begin
FListView.Columns.BeginUpdate;
FListView.Columns.Clear;
For I:=0 To FPocetSloupcu-1 Do
    begin
    If SloupecDejStav(I) Then
       ListViewPridejSloupec(I);
    end;
FListView.Columns.EndUpdate;
end;

Function  TSortList.SloupecDejStav(Cislo:Integer):Boolean;
begin
Result:=(Cislo In FSloupce);
end;

Procedure TSortList.SloupecZmenStav(Cislo:Integer; Pridej:Boolean);
begin
If Pridej Then
   Include(FSloupce,Cislo)
Else Exclude(FSloupce,Cislo);
end;

Function TSortList.JmenoSloupceNaCislo(Jmeno:String):Integer;
begin
Result:=FJmena.IndexOf(Jmeno);
end;

Function TSortList.CisloSloupceNaJmeno(Cislo:Integer):String;
begin
Result:=FJmena[Cislo];
end;

End.
